VERSION 8000;;8307
* Achse_FehlstationenListen.CSX  18.02.10
* -----------------------------------------------------------------------------
* @filedoc
* @file Achse_FehlstationenListen.CSX
* @brief Fehlstationen achsbezogen protokollieren 
* 
* Dieses Beispielskript protokolliert alle Achsen, fr die Fehlstationen festgelegt wurden.
* Das Protokoll enthlt folgende Angaben:  
* Achsnummer und Bezeichnung, Name der Fehlstation, ankommende und abgehende Station, 
* Kilometrierungssprung mit Angabe berlnge oder Fehllnge. 
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author CK
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------

* --- Vereinbarungen ----------------------------------------------------------

BILDSCHIRM GRAFIK

* --- Deklarationen -----------------------------------------------------------

SYMBOLE /ALIGNMENTSYS/ AchsSys                             | Symbol fr das System der Achsen
SYMBOLE /ALIGNMENT/ Achse                                  | Symbol fr die Achse
SYMBOLE /DISCONTINUITY/ Fehlstat                           | Symbol fr die Fehlstation

SYMBOLE * I; IF; Anz_A; !AchsBez; FStatAnz; !FName; FAnkStat; FAbgStat; KmSprung; !FLaenge  
            
* --- Ausfhrungen ------------------------------------------------------------

AchsSys = Project.GetAlignmentSys()                        | liefert das Objekt fr das System der Achsen 

* Ausgabe ins Protokoll  
MELDE " Fehlstationen achsbezogen protokollieren"                 
MELDE "========================================="
MELDE " Achsnr.| Bezeichnung                              | Fehlstation         | ankomm. Stat. | abgeh. Stat. | Kilometr.sprung [m]  "
MELDE "-------------------------------------------------------------------------------------------------------------------------------"
 
* Schleife ber alle Achsen
Anz_A = 0                                                  | Zhler fr die Anzahl der Achsen
SCHLEIFE I = 1; 9999
  Achse = AchsSys.GetAlignment(I)                          | liefert das Achsobjekt
  WENN Achse == $NULL DANN ABBRUCH SCHLEIFE           
  FStatAnz = Achse.GetNumberOfDiscont()                    | liefert die Anzahl der Fehlstationen
  WENN FStatAnz > 0 DANN                                   | Achse nur listen, wenn mind. 1 Fehlstaion vorhanden ist
    !AchsBez = Achse.GetDescription()                      | liefert die Achsbezeichnung
    Anz_A = Anz_A + 1
 
    * Schleife ber alle Fehlstationen der Achse
    SCHLEIFE IF = 1; FStatAnz; 1                       
      Fehlstat = Achse.GetDiscontinuity(IF)                | liefert das Objekt fr die Fehlstation
      !FName = Fehlstat.GetName()                          | Liefert den Namen der Fehlstation
      FAnkStat = Fehlstat.GetIncomingValue() 	           | liefert den Stationswert der ankommenden Station
      FAbgStat = Fehlstat.GetOutgoingValue()               | liefert den Stationswert der abgehenden Station
      KmSprung = Fehlstat.GetDiscontinuity()               | liefert den Kilometrierungssprung   
      WENN KmSprung < 0 DANN !FLaenge = "berlnge"  	
      WENN KmSprung > 0 DANN !FLaenge = "Fehllnge"
 
      * Ausgabe der Werte ins Protokoll	
      MELDE "   #### | ######################################## | ####################|    #####.#### |   #####.#### | ####.####  #  ";I;!AchsBez;!FName;FAnkStat;FAbgStat;KmSprung;!FLaenge 
    ENDE SCHLEIFE
  WEITER
  
ENDE SCHLEIFE 

MELDE "-------------------------------------------------------------------------------------------------------------------------------"
MELDE "Anzahl Achsen mit Fehlstationen im Projekt: #"; Anz_A    | Ausgabe der Achsanzahl
MELDE "==============================================="  
